<?php
namespace Modules\User\Requests\Api;


use Illuminate\Support\Facades\Request;
use Illuminate\Validation\Rule;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\User\Services\AccountService;

class SetAddressRequest extends FormRequest
{
    private AccountService $accountService ;
    public function __construct(  AccountService $accountService)
    {
        $this->accountService = $accountService;
    }
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $account = $this->accountService->getAccount();
        
        $rules = [
            'address_id'=> [
                "required",
                Rule::exists('addresses','id')->where('user_status',$account['status'])->where('user_id',$account['user']->id)
            ],
        ];

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes = [
            'address_id' =>  __('web.address'),
        ];

        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param  \Illuminate\Contracts\Validation\Validator  $validator
     * @return void
     *
     * @throws \Illuminate\Validation\ValidationException
     */
     protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        
            $errors = (new ValidationException($validator))->errors();
            $message = $validator->errors()->first();
            throw new HttpResponseException(response()->json(['message'=> $message, 'errors' => $errors],  400));
       
    }
}